var CookieConsent = Class.create({
  initialize : function(settings) {
    this.settings = settings;
    //this.clearCookie('cookieConsent'); // for debugging
    if(!this.getCookie('cookieConsent')){
      this.showDisclaimer();
    }
    var resetCookiesButton = $('ResetCookies');
    if (resetCookiesButton != null) {
      resetCookiesButton.observe('click', function() {
        this.showDisclaimer();
      }.bind(this));
    }
  },

  getCookie : function(key)
  {
    var keyEquals = key + "=";
    var value     = false;

    document.cookie.split(';').invoke('strip').each(function(s){
      if (s.startsWith(keyEquals)) {
        value = unescape(s.substring(keyEquals.length, s.length));
      }
    });

    return value;
  },

  setCookie : function(key, value, days) {
    var setValue      = key + '=' + escape(new String(value));
    var setExpiration = "";

    if (days) {
      var date = new Date();
      date.setTime(date.getTime() + (days*24*60*60*1000));
      var setExpiration = "; expires=" + date.toGMTString();
    }

    var cookieString = setValue + setExpiration + ";path=/";
    document.cookie  = cookieString;
  },

  clearCookie : function(key) {
    this.setCookie(key,'',-1);
  },

  animation : function(event, element) {
    switch(this.settings.animation)
    {
      case 'none': 
        event == 'show' ? $(element).show() : $(element).hide(); break;
      case 'slide': 
        event == 'show' ? Effect.BlindDown(element, { duration : 1 }) : Effect.BlindUp(element, { duration : 1 }); break;
      case 'fade':
        event == 'show' ? Effect.Appear(element, { duration : 1 }) : Effect.Fade(element, { duration : 1 }); break;
    }
  },

  showDisclaimer : function() {
    clearLessCache();
    var htmlContent1 = this.settings.disclaimer1
                     + '<a href="#" class="button" role="button" name="cookieConsentHide" id="cookieConsentHide">'
                     + this.settings.buttonText
                     + '</a>'
                     + '<a href="#" class="button" role="button" name="cookieConsentConfig" id="cookieConsentConfig">'
                     + this.settings.configButtonText
                     + '</a>';
    
    var htmlContent2 = this.settings.disclaimer2
                     + '<div id="CookieSelectPane">'
                     + '<div class="CookieSelectButtonWrapper" title="' + this.settings.necessaryInfoBox + '">'
                     + '<label for="CookieButtonNecessary">'
                     + '<input id="CookieButtonNecessary" class="CookieButton" disabled="disabled" checked="checked" type="checkbox">'
                     + this.settings.mandatoryLabel + '</label>'
                     + '</div>'
                     + '<div class="CookieSelectButtonWrapper" title="' + this.settings.preferencesInfoBox + '">'
                     + '<label for="CookieButtonPreferences">'
                     + '<input id="CookieButtonPreferences" class="CookieButton" tabindex="1" type="checkbox">'
                     + this.settings.preferencesLabel + '</label>'
                     + '</div>'
                     + '<div class="CookieSelectButtonWrapper" title="' + this.settings.statisticsInfoBox + '">'
                     + '<label for="CookieButtonStatistics">'
                     + '<input id="CookieButtonStatistics" class="CookieButton" tabindex="1" type="checkbox">'
                     + this.settings.statisticsLabel + '</label>'
                     + '</div>'
                     + '<div class="CookieSelectButtonWrapper" title="' + this.settings.marketingInfoBox + '">'
                     + '<label for="CookieButtonMarketing">'
                     + '<input id="CookieButtonMarketing" class="CookieButton" tabindex="1" type="checkbox">'
                     + this.settings.marketingLabel + '</label>'
                     + '</div></div>'
                     + '<a href="#" class="button" role="button" name="cookieConsentOK" id="cookieConsentOK">OK</a>';

    var html = '<div id="cookieConsent" style="display: none;">'
             + '<div class="col-md-2"></div>'
             + '<div id="cookieConsentContent" class="col-md-8">' 
             + htmlContent1
             + '</div>'
             + '<div class="col-md-2"></div>'
             + '</div>'
             + '</div>';

    var gdprSettings = ['necessary', 'preferences','statistics','marketing'];
    $('xwikimaincontainerinner').insert( {before : html } );
    $("cookieConsentHide").observe('click', this.hideDisclaimer.bind(this, gdprSettings));
    $("cookieConsentConfig").addEventListener("click", function(){
      $("cookieConsentContent").innerHTML = htmlContent2;
      $("cookieConsentOK").observe('click', function() {
        if(!$("CookieButtonPreferences").checked){
          var index = gdprSettings.indexOf('preferences');
          if (index > -1) {
            gdprSettings.splice(index, 1);
          }
        }
        if(!$("CookieButtonStatistics").checked){
          var index = gdprSettings.indexOf('statistics');
          if (index > -1) {
            gdprSettings.splice(index, 1);
          }
        }
        if(!$("CookieButtonMarketing").checked){
          var index = gdprSettings.indexOf('marketing');
          if (index > -1) {
            gdprSettings.splice(index, 1);
          }
        }

        this.hideDisclaimer(gdprSettings);

      }.bind(this));
    }.bind(this));

    this.animation('show', 'cookieConsent');
  },

  hideDisclaimer : function(param) {
    this.setCookie('cookieConsent', 'hide', 365);
    this.setCookie('gdprSettings', param, 365);
    this.animation('hide', 'cookieConsent');
  }
});

